
*****************************************************************************
;   Base routine - disable and return operating system, inc. copper macros

;   Written - 17.1.90   Kreator - Anarchy UK
*****************************************************************************

	Incdir	DF1:
	Include	Source/CustomRegisters
	Section	Base,Code_c

Trap_vec0	= $80
Execbase	= $4

	Movem.l	d0-d7/a0-a6,-(a7)
	Move.l	#Start,Trap_vec0
	Trap	#0
	Movem.l	(a7)+,d0-d7/a0-a6
	Rts

Start
	Bsr	Killsys
	Bsr	Setup
	Bsr	Main
	Bsr	Sysreturn
	Rte

*****************************************************************************
;Killsys - Disable operating system and interrupts
*****************************************************************************
Killsys	Move	Intenar,Int_set
	Move	#$7fff,Intena
	Move	Dmaconr,Dma_set
	Move	#$7fff,Dmacon
	Move	#$87cf,Dmacon
	Move.l	Execbase,a6
	Lea	Gfxname(pc),a1
	Jsr	-
	Rts

Int_set	Dc.w	0
Dma_set	Dc.w	0

*****************************************************************************
;Sysreturn - Re-enable operating system and interrupts
*****************************************************************************
Sysreturn
	Move	#$7fff,Intena
	Move	Int_set(pc),d0
	Or	#$c000,d0
	Move	d0,Intena
	Move	#$7fff,Dmacon
	Move	Dma_set(pc),d0
	Or	#$8200,d0
	Move	d0,Dmacon


